<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:14 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>PluginAware (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="PluginAware (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/api/plugins/ObjectConfigurationAction.html" title="interface in org.gradle.api.plugins"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../org/gradle/api/plugins/PluginCollection.html" title="interface in org.gradle.api.plugins"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/plugins/PluginAware.html" target="_top">Frames</a></li>
<li><a href="PluginAware.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.api.plugins</div>
<h2 title="Interface PluginAware" class="title">Interface PluginAware</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Known Subinterfaces:</dt>
<dd><a href="../../../../org/gradle/api/invocation/Gradle.html" title="interface in org.gradle.api.invocation">Gradle</a>, <a href="../../../../org/gradle/api/Project.html" title="interface in org.gradle.api">Project</a>, <a href="../../../../org/gradle/api/initialization/Settings.html" title="interface in org.gradle.api.initialization">Settings</a></dd>
</dl>
<hr>
<br>
<pre>public interface <span class="strong">PluginAware</span></pre>
<div class="block">Something that can have plugins applied to it.
 <p>
 The <a href="../../../../org/gradle/api/plugins/PluginAware.html#getPluginManager()"><code>plugin manager</code></a> can be used for applying and detecting whether plugins have been applied.
 <p>
 For more on writing and applying plugins, see <a href="../../../../org/gradle/api/Plugin.html" title="interface in org.gradle.api"><code>Plugin</code></a>.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/plugins/PluginAware.html#apply(org.gradle.api.Action)">apply</a></strong>(<a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/plugins/ObjectConfigurationAction.html" title="interface in org.gradle.api.plugins">ObjectConfigurationAction</a>&gt;&nbsp;action)</code>
<div class="block">Applies zero or more plugins or scripts.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/plugins/PluginAware.html#apply(groovy.lang.Closure)">apply</a></strong>(<a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;closure)</code>
<div class="block">Applies zero or more plugins or scripts.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/plugins/PluginAware.html#apply(java.util.Map)">apply</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,?&gt;&nbsp;options)</code>
<div class="block">Applies a plugin or script, using the given options provided as a map.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/plugins/PluginManager.html" title="interface in org.gradle.api.plugins">PluginManager</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/plugins/PluginAware.html#getPluginManager()">getPluginManager</a></strong>()</code>
<div class="block">The plugin manager for this plugin aware object.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/plugins/PluginContainer.html" title="interface in org.gradle.api.plugins">PluginContainer</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/plugins/PluginAware.html#getPlugins()">getPlugins</a></strong>()</code>
<div class="block">The container of plugins that have been applied to this object.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getPlugins()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getPlugins</h4>
<pre><a href="../../../../org/gradle/api/plugins/PluginContainer.html" title="interface in org.gradle.api.plugins">PluginContainer</a>&nbsp;getPlugins()</pre>
<div class="block">The container of plugins that have been applied to this object.
 <p>
 While not deprecated, it is preferred to use the methods of this interface or the <a href="../../../../org/gradle/api/plugins/PluginAware.html#getPluginManager()"><code>plugin manager</code></a> than use the plugin container.
 <p>
 Use one of the 'apply' methods on this interface or on the <a href="../../../../org/gradle/api/plugins/PluginAware.html#getPluginManager()"><code>plugin manager</code></a> to apply plugins instead of applying via the plugin container.
 <p>
 Use <a href="../../../../org/gradle/api/plugins/PluginManager.html#hasPlugin(java.lang.String)"><code>PluginManager.hasPlugin(String)</code></a> or similar to query for the application of plugins instead of doing so via the plugin container.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>the plugin container</dd><dt><span class="strong">See Also:</span></dt><dd><a href="../../../../org/gradle/api/plugins/PluginAware.html#apply(groovy.lang.Closure)"><code>apply(groovy.lang.Closure)</code></a>, 
<a href="../../../../org/gradle/api/plugins/PluginManager.html#hasPlugin(java.lang.String)"><code>PluginManager.hasPlugin(String)</code></a></dd></dl>
</li>
</ul>
<a name="apply(groovy.lang.Closure)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>apply</h4>
<pre>void&nbsp;apply(<a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/Closure.html?is-external=true" title="class or interface in groovy.lang">Closure</a>&nbsp;closure)</pre>
<div class="block">Applies zero or more plugins or scripts.
 <p>
 The given closure is used to configure an <a href="../../../../org/gradle/api/plugins/ObjectConfigurationAction.html" title="interface in org.gradle.api.plugins"><code>ObjectConfigurationAction</code></a>, which “builds” the plugin application.
 <p>
 This method differs from <a href="../../../../org/gradle/api/plugins/PluginAware.html#apply(java.util.Map)"><code>apply(java.util.Map)</code></a> in that it allows methods of the configuration action to be invoked more than once.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>closure</code> - the closure to configure an <a href="../../../../org/gradle/api/plugins/ObjectConfigurationAction.html" title="interface in org.gradle.api.plugins"><code>ObjectConfigurationAction</code></a> with before “executing” it</dd><dt><span class="strong">See Also:</span></dt><dd><a href="../../../../org/gradle/api/plugins/PluginAware.html#apply(java.util.Map)"><code>apply(java.util.Map)</code></a></dd></dl>
</li>
</ul>
<a name="apply(org.gradle.api.Action)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>apply</h4>
<pre>void&nbsp;apply(<a href="../../../../org/gradle/api/Action.html" title="interface in org.gradle.api">Action</a>&lt;? super <a href="../../../../org/gradle/api/plugins/ObjectConfigurationAction.html" title="interface in org.gradle.api.plugins">ObjectConfigurationAction</a>&gt;&nbsp;action)</pre>
<div class="block">Applies zero or more plugins or scripts.
 <p>
 The given closure is used to configure an <a href="../../../../org/gradle/api/plugins/ObjectConfigurationAction.html" title="interface in org.gradle.api.plugins"><code>ObjectConfigurationAction</code></a>, which “builds” the plugin application.
 <p>
 This method differs from <a href="../../../../org/gradle/api/plugins/PluginAware.html#apply(java.util.Map)"><code>apply(java.util.Map)</code></a> in that it allows methods of the configuration action to be invoked more than once.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>action</code> - the action to configure an <a href="../../../../org/gradle/api/plugins/ObjectConfigurationAction.html" title="interface in org.gradle.api.plugins"><code>ObjectConfigurationAction</code></a> with before “executing” it</dd><dt><span class="strong">See Also:</span></dt><dd><a href="../../../../org/gradle/api/plugins/PluginAware.html#apply(java.util.Map)"><code>apply(java.util.Map)</code></a></dd></dl>
</li>
</ul>
<a name="apply(java.util.Map)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>apply</h4>
<pre>void&nbsp;apply(<a href="https://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,?&gt;&nbsp;options)</pre>
<div class="block">Applies a plugin or script, using the given options provided as a map. Does nothing if the plugin has already been applied.
 <p>
 The given map is applied as a series of method calls to a newly created <a href="../../../../org/gradle/api/plugins/ObjectConfigurationAction.html" title="interface in org.gradle.api.plugins"><code>ObjectConfigurationAction</code></a>.
 That is, each key in the map is expected to be the name of a method <a href="../../../../org/gradle/api/plugins/ObjectConfigurationAction.html" title="interface in org.gradle.api.plugins"><code>ObjectConfigurationAction</code></a> and the value to be compatible arguments to that method.

 <p>The following options are available:</p>

 <ul><li><code>from</code>: A script to apply. Accepts any path supported by <a href="../../../../org/gradle/api/Project.html#uri(java.lang.Object)"><code>Project.uri(Object)</code></a>.</li>

 <li><code>plugin</code>: The id or implementation class of the plugin to apply.</li>

 <li><code>to</code>: The target delegate object or objects. The default is this plugin aware object. Use this to configure objects other than this object.</li></ul></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>options</code> - the options to use to configure and <a href="../../../../org/gradle/api/plugins/ObjectConfigurationAction.html" title="interface in org.gradle.api.plugins"><code>ObjectConfigurationAction</code></a> before “executing” it</dd></dl>
</li>
</ul>
<a name="getPluginManager()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>getPluginManager</h4>
<pre><a href="../../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
<a href="../../../../org/gradle/api/plugins/PluginManager.html" title="interface in org.gradle.api.plugins">PluginManager</a>&nbsp;getPluginManager()</pre>
<div class="block">The plugin manager for this plugin aware object.</div>
<dl><dt><span class="strong">Returns:</span></dt><dd>the plugin manager</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.3</dd></dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/api/plugins/ObjectConfigurationAction.html" title="interface in org.gradle.api.plugins"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../org/gradle/api/plugins/PluginCollection.html" title="interface in org.gradle.api.plugins"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/plugins/PluginAware.html" target="_top">Frames</a></li>
<li><a href="PluginAware.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
